/* This file is part of Om.  Copyright (C) 2004 Dave Robillard.
 * 
 * Om is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * Om is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef NEWPATCHWINDOW_H
#define NEWPATCHWINDOW_H

#include <gtkmm.h>
#include <libglademm.h>

namespace OmGtk {
	

/** 'New Patch' Window.
 *
 * Loaded by libglade as a derived object.
 * This is the window used for creating new top-level patches (not subpatches)
 *
 * \ingroup OmGtk
 */
class NewPatchWindow : public Gtk::Window
{
public:
	NewPatchWindow(BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade);

	void cancel_clicked();
	void ok_clicked();

private:
	Gtk::Entry*      m_name_entry;
	Gtk::SpinButton* m_poly_spinbutton;
	Gtk::Button*     m_cancel_button;
	Gtk::Button*     m_ok_button;
};

} // namespace OmGtk

#endif // NEWPATCHWINDOW_H
