/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  gengetopt -u 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("   -h         --help                Print help and exit\n");
  printf("   -V         --version             Print version and exit\n");
  printf("   -HSTRING   --host=STRING         Om engine host (default='localhost')\n");
  printf("   -pINT      --port=INT            Om engine port (must be specified if host is given)\n");
  printf("   -uSTRING   --url=STRING          Om engine URL (can not be specified if host/port is given)\n");
  printf("   -cSTRING   --client-host=STRING  Client host to report to engine (bug workaround)\n");
  printf("   -oINT      --client-port=INT     Client port to report to engine (bug workaround)\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->host_given = 0 ;
  args_info->port_given = 0 ;
  args_info->url_given = 0 ;
  args_info->client_host_given = 0 ;
  args_info->client_port_given = 0 ;
#define clear_args() { \
  args_info->host_arg = gengetopt_strdup("localhost") ;\
  args_info->url_arg = NULL; \
  args_info->client_host_arg = NULL; \
}

  clear_args();

  args_info->inputs = NULL;
  args_info->inputs_num = 0;

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "host",	1, NULL, 'H' },
        { "port",	1, NULL, 'p' },
        { "url",	1, NULL, 'u' },
        { "client-host",	1, NULL, 'c' },
        { "client-port",	1, NULL, 'o' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVH:p:u:c:o:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'H':	/* Om engine host.  */
          if (args_info->host_given)
            {
              fprintf (stderr, "%s: `--host' (`-H') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->host_given = 1;
          args_info->host_arg = gengetopt_strdup (optarg);
          break;

        case 'p':	/* Om engine port (must be specified if host is given).  */
          if (args_info->port_given)
            {
              fprintf (stderr, "%s: `--port' (`-p') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->port_given = 1;
          args_info->port_arg = strtol (optarg,&stop_char,0);
          break;

        case 'u':	/* Om engine URL (can not be specified if host/port is given).  */
          if (args_info->url_given)
            {
              fprintf (stderr, "%s: `--url' (`-u') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->url_given = 1;
          args_info->url_arg = gengetopt_strdup (optarg);
          break;

        case 'c':	/* Client host to report to engine (bug workaround).  */
          if (args_info->client_host_given)
            {
              fprintf (stderr, "%s: `--client-host' (`-c') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->client_host_given = 1;
          args_info->client_host_arg = gengetopt_strdup (optarg);
          break;

        case 'o':	/* Client port to report to engine (bug workaround).  */
          if (args_info->client_port_given)
            {
              fprintf (stderr, "%s: `--client-port' (`-o') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->client_port_given = 1;
          args_info->client_port_arg = strtol (optarg,&stop_char,0);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */


  if ( missing_required_options )
    exit (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;
}
