/* This file is part of Om.  Copyright (C) 2004 Dave Robillard.
 * 
 * Om is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * Om is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "SendPluginsEvent.h"
#include "Om.h"
#include "OSCSender.h"

namespace Om {


SendPluginsEvent::SendPluginsEvent(Request request)
: SlowEvent(request)
{
}

// I guess this doesn't need to be a slow event?
void
SendPluginsEvent::prepare()
{
	SlowEvent::prepare();
}


void
SendPluginsEvent::execute(uint sample_offset)
{
	SlowEvent::execute(sample_offset);
}


void
SendPluginsEvent::post_process()
{
	m_request.respond_ok();
	om->osc_sender()->send_plugins(m_request.source());
}


} // namespace Om

